/**************************************************************************************************
    Filename:       at_multi_role_Main.c
    Revised:        $Date: 2022-08-31 $
    Revision:       $Revision: 11 $

    Description:    This file contains the main and callback functions for
                  the BLE AT Proj application.

**************************************************************************************************/

/**************************************************************************************************
                                             Includes
 **************************************************************************************************/
/* Hal Drivers */

/* OSAL */
#include "OSAL.h"
#include "OSAL_Tasks.h"
#include "OSAL_PwrMgr.h"

/**************************************************************************************************
    FUNCTIONS
 **************************************************************************************************/

/**************************************************************************************************
    @fn          main

    @brief       Start of application.

    @param       none

    @return      none
 **************************************************************************************************
*/
int app_main(void)
{
    /* Initialize the operating system */
    osal_init_system();
    osal_pwrmgr_device( PWRMGR_BATTERY );
    /* Start OSAL */
    osal_start_system(); // No Return from here
    return 0;
}
/**************************************************************************************************
                                           CALL-BACKS
**************************************************************************************************/


/*************************************************************************************************
**************************************************************************************************/
